#!/usr/local/bin/perl

=head1 スクリプト名

wemo_list.cgi - Wemoデータリスト出力

=head1 概要

メモデータの表示。メモ格納ディレクトリの yyyy-mm-ddThh-mm-ss.txt ファイルのリストとwemo.cgi起動用のファイルへのリンクを生成する。

=cut
use CGI qw(:cgi);

# 環境変数の取得
$docroot = "/homepage";
$cgidir = "/cgi-bin";# $ENV{'CGIDIR'};

# メモを格納するディレクトリ名
$memodir = "memo";

# メモのカテゴリのASCII文字列をキーに日本語文字列を連想配列の値として取得
# メモ格納ディレクトリにある category.txt から読み込む
if(open(IN, "<$docroot/$memodir/category_utf-8.txt")){
	while(<IN>){
		chomp;
		($catstr, $category) = split(/\t/);
		$categories{$catstr} = $category;
	}
	close(IN);
}else{
	# category.txt が無ければ、次の連想配列のデータを使う
	%categories = (
		"favor" => "お気に入り",
		"diary" => "日記",
		"memo" => "メモ",
		"sched" => "スケジュール",
		"annot" => "註釈",
		"file" => "マイドキュメント",
	);
}

# メモの最初の部分の CGI 出力
print <<HEADER;
Content-type: text/html; charset=UTF-8

<HTML>
<HEAD>
<TITLE>Wemo List</TITLE>
<META HTTP-EQUIV="Content-Type" content="text/html; charset=UTF-8">
<link rel="stylesheet" type="text/css" href="/mystyle.css">
</HEAD>
<BODY>
<form method="POST" action="$cgidir/wemo_r2.cgi" target="submain">
Retrieval string: <input type="text" name="pattern">
<input type="submit">
<input type="reset">
</form>
<div class="emph">Wemo List</div>
<table border>
<tr><th>Date</th><th>Categ.</th><th>Title</th><th>Update</th></tr>
HEADER

opendir(DIR, "$docroot/$memodir");
if($ENV{'PATH_INFO'}){
	# 日付をyyyy-mm-dd 形式で渡す
	($memodate = $ENV{'PATH_INFO'}) =~ s/^\/(.+)$/$1/;
	@memo = grep(/$memodate/,readdir(DIR));
}else{
	# メモディレクトリのメモファイルをすべてリストアップ
	@memo = grep(/^\d{4}-\d{2}-\d{2}T\d{2}-\d{2}-\d{2}\.txt$/,readdir(DIR));
}
closedir(DIR);

foreach $memo (sort @memo){
	open(IN, "$docroot/$memodir/$memo");
	while(<IN>){
		chomp;
		if(/^(\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2} \(\w{3}\.\))$/i){
			($date = $_) =~ s/T/ /;
		}elsif(/^c: (.+)$/i){
			$category = $1;
			$catsw = 1;
		}elsif(/^t: (.+)$/i){
			$title = $1;
			$titsw = 1;
		}elsif(/^Update: (.+)$/i){
			($update = $1) =~ s/T/ /;
			$udsw = 1;
		}
	}
	close(IN);
	if($catsw == 1 && $titsw == 1 && $udsw ==1){
		print "<tr><td><a href=\"$cgidir/wemo.cgi/$memo\">$date</a></td><td>$categories{$category}</td><td>$title</td><td>$update</td></tr>\n" ;
	}elsif($catsw == 1 && $titsw == 1 && $udsw == 0){
		print "<tr><td><a href=\"$cgidir/wemo.cgi/$memo\">$date</a></td><td>$categories{$category}</td><td>$title</td><td></td></tr>\n" ;
	}
	$catsw = 0;$titsw = 0;$upsw = 0;
	$category = "";$title = ""; $update = "";
}
print "</table>\n";
print "<hr>\n";
print "[ <a href=\"$cgidir/wemo_calendar.cgi\">Calendar</a> ]\n";
# メモ作成・編集用フォームの CGI 出力
print "<FORM action=\"$cgidir/wemo_edit.cgi\">\n";
print "<INPUT TYPE=\"hidden\" NAME=\"today\" VALUE=\"yes\">\n";
# SELECTタグによるカテゴリの選択メニューを出力する
print "<SELECT name=\"category\" size=1>\n";
print "<OPTION selected></OPTION>\n";
# OPTIONタグで、カテゴリの選択メニューを作成する
foreach $catstr (sort keys(%categories)){
	print "<OPTION value=\"$catstr\">$categories{$catstr}</OPTION>\n";
}
print "</SELECT>\n";
# フォームの完成
print "<INPUT TYPE=\"submit\" VALUE=\"Edit Today\"></FORM>\n";
print "</BODY></HTML>\n";
__END__
#####
print " | [ <a href=\"$cgidir/wemo_edit.cgi?today=yes\">Wemo today</a> ]";
